﻿#if XBOX360
namespace System.Diagnostics
{
    [AttributeUsage(
        AttributeTargets.Delegate
      | AttributeTargets.Field
      | AttributeTargets.Property
      | AttributeTargets.Enum
      | AttributeTargets.Struct
      | AttributeTargets.Class
      | AttributeTargets.Assembly,
      AllowMultiple = true)]
    public sealed class DebuggerDisplayAttribute : Attribute
    {
        // Fields
        public string Name { get; set; }
        public Type target;
        public string TargetTypeName { get; set; }
        public string Type { get; set; }
        public string Value { get; private set; }

        public DebuggerDisplayAttribute(string value)
        {
            this.Value = value ?? string.Empty;
            this.Name = string.Empty;
            this.Type = string.Empty;
        }

        public Type Target
        {
            get { return this.target; }
            set
            {
                if (value == null)
                {
                    throw new ArgumentNullException("value");
                }
                this.TargetTypeName = value.AssemblyQualifiedName;
                this.target = value;
            }
        }
    }
}
#endif