﻿using System;
using System.Linq;
using System.Linq.Expressions;
using System.Collections.Generic;

namespace Achiral.Extension
{
    public static partial class MakeWorld
    {
        public static IEnumerable<int> UpTo(this int initial, int upto)
        {
            for (var i = initial; i <= upto; i = checked(i + 1))
            {
                yield return i;
            }
        }
        public static IEnumerable<int> DownTo(this int initial, int downto)
        {
            for (var i = initial; i >= downto; i = checked(i - 1))
            {
                yield return i;
            }

        }
        public static IEnumerable<int> UpToInfinity(this int initial)
        {
            for (var i = initial; ; i = checked(i + 1))
            {
                yield return i;
            }
        }
        public static IEnumerable<int> DownToNegativeInfinity(this int initial)
        {

            for (var i = initial; ; i = checked(i - 1))
            {
                yield return i;
            }
        }

        public static IEnumerable<long> UpTo(this long initial, long upto)
        {
            for (var i = initial; i <= upto; i = checked(i + 1))
            {
                yield return i;
            }
        }
        public static IEnumerable<long> DownTo(this long initial, long downto)
        {
            for (var i = initial; i >= downto; i = checked(i - 1))
            {
                yield return i;
            }
        }
        public static IEnumerable<long> UpToInfinity(this long initial)
        {
            for (var i = initial; ; i = checked(i + 1))
            {
                yield return i;
            }
        }
        public static IEnumerable<long> DownToNegativeInfinity(this long initial)
        {
            for (var i = initial; ; i = checked(i - 1))
            {
                yield return i;
            }
        }
    }
}