﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Reflection;
using System.Linq.Expressions;

namespace Achiral.Extension
{
    public static partial class MakeWorld
    {
        public static Type GetReturnType(this MemberInfo memberInfo)
        {
            if (memberInfo == null) return null;

            switch (memberInfo.MemberType)
            {
                case MemberTypes.Constructor:
                    var constructorInfo = memberInfo as ConstructorInfo;
                    return constructorInfo.DeclaringType;
                case MemberTypes.Field:
                    var fieldInfo = memberInfo as FieldInfo;
                    return fieldInfo.FieldType;
                case MemberTypes.Method:
                    var methodInfo = memberInfo as MethodInfo;
                    return methodInfo.ReturnType;
                case MemberTypes.Property:
                    var propertyInfo = memberInfo as PropertyInfo;
                    return propertyInfo.PropertyType;
            }
            return null;
        }
    }
}