﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace Achiral.Extension
{
    public static partial class MakeWorld
    {
        public static Maybe<TResult> Select<TResult>(this Match match, Func<Match, TResult> selector)
        {
            AssertNonNullArgument(match, "match");
            return match.Success ? Make.Maybe(selector(match)) : new Maybe<TResult>();
        }
        public static IEnumerable<TResult> Select<TResult>(this MatchCollection matches, Func<Match, TResult> selector)
        {
            AssertNonNullArgument(matches, "matches");

            return matches.Count > 0 ? matches.Cast<Match>().Select(selector) : Enumerable.Empty<TResult>();
        }
    }
}
