﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for StringTest
    /// </summary>
    [TestClass]
    public class EventHandlerTest
    {
        public EventHandlerTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void InvokeOrNop_Test1()
        {
            var testInst = new MethodCallTestClass();

            var handler = new EventHandler(testInst.MethodCallTestMethod<EventArgs>);

            handler.InvokeOrNop(this, new EventArgs());

            Assert.IsTrue(testInst.Called);

            bool hasException = false;
            handler = null;
            try
            {
                handler.InvokeOrNop(this, new EventArgs());
            }
            catch
            {
                hasException = true;
            }
            Assert.IsFalse(hasException);
        }

        [TestMethod]
        public void InvokeOrNop_Test2()
        {
            var testInst = new MethodCallTestClass();

            var handler = new EventHandler<EventArgs>(testInst.MethodCallTestMethod<EventArgs>);

            handler.InvokeOrNop(this, new EventArgs());

            Assert.IsTrue(testInst.Called);

            bool hasException = false;
            handler = null;
            try
            {
                handler.InvokeOrNop(this, new EventArgs());
            }
            catch
            {
                hasException = true;
            }
            Assert.IsFalse(hasException);
        }

        internal class MethodCallTestClass
        {
            public bool Called = false;
            public void MethodCallTestMethod<TEventArgs>(object sender, TEventArgs eventArgs) where TEventArgs : EventArgs
            {
                this.Called = true;
            }
        }
    }
}
