﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for TupleTest
    /// </summary>
    [TestClass]
    public class ExpressionTest
    {
        public ExpressionTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }


        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void Expression_OrElseTest()
        {
            var func = Make.Expression((int x) => x%3 == 0).OrElse(x => x%3 == 1).Compile();
            Assert.IsTrue(func(0));
            Assert.IsTrue(func(1));
            Assert.IsFalse(func(2));
        }

        [TestMethod]
        public void Expression_AndAlsoTest()
        {
            var func = Make.Expression((int x) => x % 2 == 0).AndAlso(x => x > 0).Compile();
            Assert.IsFalse(func(-2));
            Assert.IsFalse(func(0));
            Assert.IsTrue(func(2));
        }

        [TestMethod]
        public void Expression_NotTest()
        {
            var func = Make.Expression((int x) => x % 2 == 0).Not().Compile();
            Assert.IsFalse(func(0));
            Assert.IsTrue(func(1));
        }
    }
}
