﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;
using System.Reflection;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class IntTest
    {
        public IntTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void UpTo_Test_Int32()
        {
            Assert.IsTrue(10.UpTo(13).SequenceEqual(new[] { 10, 11, 12, 13 }));
            Assert.IsFalse(13.UpTo(10).Any());

            Assert.IsTrue(10.UpToInfinity().Take(4).SequenceEqual(new[] { 10, 11, 12, 13 }));

            try
            {
                var seq = Int32.MaxValue
                               .UpToInfinity()
                               .Take(3)
                               .ToArray();
                Assert.Fail();
            }
            catch (OverflowException)
            {

            }
            catch (Exception)
            {
                Assert.Fail();
            }
        }

        [TestMethod]
        public void DownTo_Test_Int32()
        {
            Assert.IsFalse(10.DownTo(13).Any());
            Assert.IsTrue(13.DownTo(10).SequenceEqual(new[] { 13, 12, 11, 10 }));

            Assert.IsTrue(0.DownToNegativeInfinity().Take(4).SequenceEqual(new[] { 0, -1, -2, -3 }));

            try
            {
                var seq = Int32.MinValue
                               .DownToNegativeInfinity()
                               .Take(3)
                               .ToArray();
                Assert.Fail();
            }
            catch (OverflowException)
            {

            }
            catch (Exception)
            {
                Assert.Fail();
            }
        }

        [TestMethod]
        public void UpTo_Test_Int64()
        {
            Assert.IsTrue(10L.UpTo(13L).SequenceEqual(new[] { 10L, 11L, 12L, 13L }));
            Assert.IsFalse(13L.UpTo(10L).Any());

            try
            {
                var seq = Int64.MaxValue
                               .UpToInfinity()
                               .Take(3)
                               .ToArray();
                Assert.Fail();
            }
            catch (OverflowException)
            {

            }
            catch (Exception)
            {
                Assert.Fail();
            }
        }

        [TestMethod]
        public void DownTo_Test_Int64()
        {
            Assert.IsFalse(10L.DownTo(13L).Any());
            Assert.IsTrue(13L.DownTo(10L).SequenceEqual(new[] { 13L, 12L, 11L, 10L }));

            Assert.IsTrue(0L.DownToNegativeInfinity().Take(4).SequenceEqual(new[] { 0L, -1L, -2L, -3L }));

            try
            {
                var seq = Int64.MinValue
                               .DownToNegativeInfinity()
                               .Take(3)
                               .ToArray();
                Assert.Fail();
            }
            catch (OverflowException)
            {

            }
            catch (Exception)
            {
                Assert.Fail();
            }
        }
    }

    

}
