﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;
using System.Linq.Expressions;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for StringTest
    /// </summary>
    [TestClass]
    public class LangTest
    {
        public LangTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        static Tuple<Expression,Func<T, T, bool>> MakeEq<T>()
        {
            var src1 = Expression.Parameter(typeof(T), "obj1");
            var src2 = Expression.Parameter(typeof(T), "obj2");
            var expr = Make.EqualityExpression(src1, src2);
            return Make.Tuple(expr, Expression.Lambda<Func<T, T, bool>>(expr, src1, src2).Compile());
        }

        [TestMethod]
        public void LangTest_EqualityExpressionTest1()
        {
            var seq =
            new[]{
                MakeEq<TestClass1>().Select( (Expr, func) => new {Expr, Result = func(new TestClass1(1), new TestClass1(1))}),
                MakeEq<TestClass2>().Select( (Expr, func) => new {Expr, Result = func(new TestClass2(1), new TestClass2(1))}),
                MakeEq<TestClass3>().Select( (Expr, func) => new {Expr, Result = func(new TestClass3(1), new TestClass3(1))}),
                MakeEq<TestClass4>().Select( (Expr, func) => new {Expr, Result = func(new TestClass4(1), new TestClass4(1))}),
                MakeEq<TestClass5>().Select( (Expr, func) => new {Expr, Result = func(new TestClass5(1), new TestClass5(1))}),
                MakeEq<TestClass6>().Select( (Expr, func) => new {Expr, Result = func(new TestClass6(1), new TestClass6(1))}),
            }.ToArray();

            Assert.IsTrue(seq.Select(result => result.Result).SequenceEqual(new[] { false, true, true, true, true, true }));
        }


        private class TestClass1
        {
            readonly int Value;
            public TestClass1(int value)
            {
                this.Value = value;
            }
        }
        private class TestClass2
        {
            readonly int Value;
            public TestClass2(int value)
            {
                this.Value = value;
            }
            public override bool Equals(object obj)
            {
                return obj is TestClass2 ? Value == (obj as TestClass2).Value
                                         : false;
            }
            public override int GetHashCode()
            {
                return Value.GetHashCode();
            }
        }
        public class TestClass3
        {
            readonly int Value;
            public TestClass3(int value)
            {
                this.Value = value;
            }
            public override bool Equals(object obj)
            {
                return obj is TestClass3 ? this.Equals(obj as TestClass3)
                                         : false;
            }
            public bool Equals(TestClass3 obj)
            {
                return Value == (obj as TestClass3).Value;
            }
            public override int GetHashCode()
            {
                return Value.GetHashCode();
            }
        }
        private class TestClass4
        {
            readonly int Value;
            public TestClass4(int value)
            {
                this.Value = value;
            }
            public override bool Equals(object obj)
            {
                return obj is TestClass4 ? this.Equals(obj as TestClass4)
                                         : false;
            }
            public bool Equals(TestClass4 obj)
            {
                return Value == (obj as TestClass4).Value;
            }
            public override int GetHashCode()
            {
                return Value.GetHashCode();
            }
            public static bool operator ==(TestClass4 obj1, TestClass4 obj2)
            {
                return obj1.Equals(obj2);
            }
            public static bool operator !=(TestClass4 obj1, TestClass4 obj2)
            {
                return !obj1.Equals(obj2);
            }
        }

        private class TestClass5 : IEquatable<TestClass5>
        {
            readonly int Value;
            public TestClass5(int value)
            {
                this.Value = value;
            }
            public override bool Equals(object obj)
            {
                return obj is TestClass5 ? this.Equals(obj as TestClass5)
                                         : false;
            }
            public bool Equals(TestClass5 obj)
            {
                return Value == (obj as TestClass5).Value;
            }
            public override int GetHashCode()
            {
                return Value.GetHashCode();
            }
            public static bool operator ==(TestClass5 obj1, TestClass5 obj2)
            {
                return obj1.Equals(obj2);
            }
            public static bool operator !=(TestClass5 obj1, TestClass5 obj2)
            {
                return !obj1.Equals(obj2);
            }
        }
#pragma warning disable 660,661
        private class TestClass6
        {
            readonly int Value;
            public TestClass6(int value)
            {
                this.Value = value;
            }
            public static bool operator ==(TestClass6 obj1, TestClass6 obj2)
            {
                return obj1.Value == obj2.Value;
            }
            public static bool operator !=(TestClass6 obj1, TestClass6 obj2)
            {
                return obj1.Value != obj2.Value;
            }
        }
#pragma warning restore 660,661
    }
}
