﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for StringTest
    /// </summary>
    [TestClass]
    public class MethodInfoTest
    {
        public MethodInfoTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void CreateFunc_Test1()
        {
            var func1 = Make.Func<int>(() => 0).Method.CreateFunc(typeof(int));
            var func2 = Make.Func<string, int>(_ => 0).Method.CreateFunc(typeof(string), typeof(int));
            var func3 = Make.Func<int, string, int>((_, __) => 0).Method.CreateFunc(typeof(int), typeof(string), typeof(int));
            var func4 = Make.Func<string, int, string, int>((_, __, ___) => 0).Method.CreateFunc(typeof(string), typeof(int), typeof(string), typeof(int));
            var func5 = Make.Func<int, string, int, string, int>((_, __, ___, ____) => 0).Method.CreateFunc(typeof(int), typeof(string), typeof(int), typeof(string), typeof(int));

            Assert.IsInstanceOfType(func1, typeof(Func<int>));
            Assert.IsInstanceOfType(func2, typeof(Func<string, int>));
            Assert.IsInstanceOfType(func3, typeof(Func<int, string, int>));
            Assert.IsInstanceOfType(func4, typeof(Func<string, int, string, int>));
            Assert.IsInstanceOfType(func5, typeof(Func<int, string, int, string, int>));
        }


        [TestMethod]
        public void CreateFunc_Test2()
        {
            var func1 = Make.Func<int>(() => 0).Method.CreateFunc(Make.Array(typeof(int)));
            var func2 = Make.Func<string, int>(_ => 0).Method.CreateFunc(Make.Array(typeof(string), typeof(int)));
            var func3 = Make.Func<int, string, int>((_, __) => 0).Method.CreateFunc(Make.Array(typeof(int), typeof(string), typeof(int)));
            var func4 = Make.Func<string, int, string, int>((_, __, ___) => 0).Method.CreateFunc(Make.Array(typeof(string), typeof(int), typeof(string), typeof(int)));
            var func5 = Make.Func<int, string, int, string, int>((_, __, ___, ____) => 0).Method.CreateFunc(Make.Array(typeof(int), typeof(string), typeof(int), typeof(string), typeof(int)));

            Assert.IsInstanceOfType(func1, typeof(Func<int>));
            Assert.IsInstanceOfType(func2, typeof(Func<string, int>));
            Assert.IsInstanceOfType(func3, typeof(Func<int, string, int>));
            Assert.IsInstanceOfType(func4, typeof(Func<string, int, string, int>));
            Assert.IsInstanceOfType(func5, typeof(Func<int, string, int, string, int>));
        }

        [TestMethod]
        public void CreateFunc_Test3()
        {
            var func1 = Make.Func<int>(() => 0).Method.CreateFunc<int>();
            var func2 = Make.Func<string, int>(_ => 0).Method.CreateFunc<string, int>();
            var func3 = Make.Func<int, string, int>((_, __) => 0).Method.CreateFunc<int, string, int>();
            var func4 = Make.Func<string, int, string, int>((_, __, ___) => 0).Method.CreateFunc<string, int, string, int>();
            var func5 = Make.Func<int, string, int, string, int>((_, __, ___, ____) => 0).Method.CreateFunc<int, string, int, string, int>();

            Assert.IsInstanceOfType(func1, typeof(Func<int>));
            Assert.IsInstanceOfType(func2, typeof(Func<string, int>));
            Assert.IsInstanceOfType(func3, typeof(Func<int, string, int>));
            Assert.IsInstanceOfType(func4, typeof(Func<string, int, string, int>));
            Assert.IsInstanceOfType(func5, typeof(Func<int, string, int, string, int>));
        }

        [TestMethod]
        public void CreateAction_Test1()
        {
            var act0 = Make.Action(() => { }).Method.CreateAction();
            var act1 = Make.Action<string>((_) => { }).Method.CreateAction(typeof(string));
            var act2 = Make.Action<int, string>((_, __) => { }).Method.CreateAction(typeof(int), typeof(string));
            var act3 = Make.Action<string, int, string>((_, __, ___) => { }).Method.CreateAction(typeof(string), typeof(int), typeof(string));
            var act4 = Make.Action<int, string, int, string>((_, __, ___, ____) => { }).Method.CreateAction(typeof(int), typeof(string), typeof(int), typeof(string));

            Assert.IsInstanceOfType(act0, typeof(Action));
            Assert.IsInstanceOfType(act1, typeof(Action<string>));
            Assert.IsInstanceOfType(act2, typeof(Action<int, string>));
            Assert.IsInstanceOfType(act3, typeof(Action<string, int, string>));
            Assert.IsInstanceOfType(act4, typeof(Action<int, string, int, string>));
        }

        [TestMethod]
        public void CreateAction_Test2()
        {
            var act0 = Make.Action(() => { }).Method.CreateAction(Enumerable.Empty<Type>().ToArray());
            var act1 = Make.Action<string>((_) => { }).Method.CreateAction(Make.Array(typeof(string)));
            var act2 = Make.Action<int, string>((_, __) => { }).Method.CreateAction(Make.Array(typeof(int), typeof(string)));
            var act3 = Make.Action<string, int, string>((_, __, ___) => { }).Method.CreateAction(Make.Array(typeof(string), typeof(int), typeof(string)));
            var act4 = Make.Action<int, string, int, string>((_, __, ___, ____) => { }).Method.CreateAction(Make.Array(typeof(int), typeof(string), typeof(int), typeof(string)));

            Assert.IsInstanceOfType(act0, typeof(Action));
            Assert.IsInstanceOfType(act1, typeof(Action<string>));
            Assert.IsInstanceOfType(act2, typeof(Action<int, string>));
            Assert.IsInstanceOfType(act3, typeof(Action<string, int, string>));
            Assert.IsInstanceOfType(act4, typeof(Action<int, string, int, string>));
        }

        [TestMethod]
        public void CreateAction_Test3()
        {
            var act0 = Make.Action(() => { }).Method.CreateAction();
            var act1 = Make.Action<string>((_) => { }).Method.CreateAction<string>();
            var act2 = Make.Action<int, string>((_, __) => { }).Method.CreateAction<int, string>();
            var act3 = Make.Action<string, int, string>((_, __, ___) => { }).Method.CreateAction<string, int, string>();
            var act4 = Make.Action<int, string, int, string>((_, __, ___, ____) => { }).Method.CreateAction<int, string, int, string>();

            Assert.IsInstanceOfType(act0, typeof(Action));
            Assert.IsInstanceOfType(act1, typeof(Action<string>));
            Assert.IsInstanceOfType(act2, typeof(Action<int, string>));
            Assert.IsInstanceOfType(act3, typeof(Action<string, int, string>));
            Assert.IsInstanceOfType(act4, typeof(Action<int, string, int, string>));
        }

        private void DummyAction(int a1, int a2, int a3, int a4, int a5, int a6)
        {

        }

        [TestMethod]
        public void CreateAction_FailTest()
        {
            bool hasException = false;
            var delg = Make.MethodInfo(() => DummyAction(0, 0, 0, 0, 0, 0));
            try
            {
                var act = delg.CreateAction(Enumerable.Repeat(typeof(int), 6).ToArray());
            }
            catch
            {
                hasException = true;
            }
            Assert.IsTrue(hasException);
        }

        private int DummyFunc(int a1, int a2, int a3, int a4, int a5)
        {
            return 0;
        }

        [TestMethod]
        public void CreateFunc_FailTest()
        {
            bool hasException = false;
            var delg = Make.MethodInfo(() => DummyFunc(0, 0, 0, 0, 0));
            try
            {
                var func = delg.CreateFunc(Enumerable.Repeat(typeof(int), 6).ToArray());
            }
            catch
            {
                hasException = true;
            }
            Assert.IsTrue(hasException);
        }

        [TestMethod]
        public void CreateDelegate_RecieverTest()
        {
            var testInst = new MethodCallTestClass();

            var act = Make.MethodInfo(() => testInst.MethodCallTestMethod())
                          .CreateDelegate<Action, MethodCallTestClass>(testInst);

            act();

            Assert.IsTrue(testInst.Called);
        }

        internal class MethodCallTestClass
        {
            public bool Called = false;
            public void MethodCallTestMethod()
            {
                this.Called = true;
            }
        }
    }
}
