﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;
using System.Linq.Expressions;
using System.Reflection;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for StringTest
    /// </summary>
    [TestClass]
    public class MemberInfoTest
    {
        public MemberInfoTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void GetReturnType_Test1()
        {
            var seq = new MemberInfo[]
                      {
                          Make.MethodInfo(() => String.Compare("A", "B")),
                          Make.PropertyInfo(() => "A".Length),
                          Make.FieldInfo(() => DateTime.MinValue),
                          Make.ConstructorInfo(() => new List<int>()),
                      }
                      .Select( memberInfo => memberInfo.GetReturnType() );

            var expecteds = new[] { typeof(int), typeof(int), typeof(DateTime), typeof(List<int>) };
            Assert.IsTrue(seq.SequenceEqual(expecteds));
        }

    }
}
