﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;
using System.Reflection;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class TypeTest
    {
        public TypeTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TypeInfo_Test1()
        {
            Assert.AreEqual(3, typeof(ConstructorInfoTestTarget).GetAllDeclaredConstructors().Count(), "GetAllConstructors");
            Assert.AreEqual(4, typeof(FieldInfoTestTarget).GetAllDeclaredFields().Count(), "GetAllDeclaredFields");
            Assert.AreEqual(4, typeof(MethodInfoTestTarget).GetAllDeclaredMethods().Count(), "GetAllDeclaredFields");
            Assert.AreEqual(5, typeof(MethodInfoTestTarget).GetAllDeclaredMembers().Count(), "GetAllDeclaredMembers");
            Assert.AreEqual(4, typeof(PropertyInfoTestTarget).GetAllDeclaredProperties().Count(), "GetAllDeclaredProperties");

            Assert.AreEqual(3, typeof(ConstructorInfoTestTarget).GetAllFlattenConstructors().Count(), "GetAllFlattenConstructors");
            Assert.AreEqual(6, typeof(FieldInfoTestTarget).GetAllFlattenFields().Count(), "GetAllFlattenFields");
            Assert.AreEqual(16, typeof(MethodInfoTestTarget).GetAllFlattenMethods().Count(), "GetAllFlattenMethods");
            Assert.AreEqual(17, typeof(MethodInfoTestTarget).GetAllFlattenMembers().Count(), "GetAllFlattenMembers");
            Assert.AreEqual(6, typeof(PropertyInfoTestTarget).GetAllFlattenProperties().Count(), "GetAllFlattenProperties");
        }

        [TestMethod]
        public void TypeInfo_Test2()
        {
            Assert.IsTrue(typeof(FieldInfoTestTarget).GetAllDeclaredConstructors()
                                                     .OfType<ConstructorInfo>()
                                                     .Any());
        }

        [TestMethod]
        public void Type_GetHierarchyLevelTest1()
        {
            Assert.AreEqual(0, typeof(object).GetHierarchyLevel(), "GetHierarchyLevel");
            Assert.AreEqual(1, typeof(string).GetHierarchyLevel(), "GetHierarchyLevel");
            Assert.AreEqual(2, typeof(int).GetHierarchyLevel(), "GetHierarchyLevel");
        }
    }

    public class PropertyInfoTestTargetBase
    {
        public int BaseProp1 { get; set; }
        public static int BaseProp2 { get; set; }
    }
    public class PropertyInfoTestTarget : PropertyInfoTestTargetBase
    {
        public int Prop1 { get; set; }
        private int Prop2 { get; set; }
        public static int Prop3 { get; set; }
        private static int Prop4 { get; set; }
    }

    public class ConstructorInfoTestTargetBase
    {
        public ConstructorInfoTestTargetBase() { }
        public ConstructorInfoTestTargetBase(int i) { }
    }

    public class ConstructorInfoTestTarget : ConstructorInfoTestTargetBase
    {
        public ConstructorInfoTestTarget() { }
        private ConstructorInfoTestTarget(int i) { }
        static ConstructorInfoTestTarget() { }
    }

    public class FieldInfoTestTargetBase
    {
        public int BaseField1;
        public static int BaseField2;
    }

    public class FieldInfoTestTarget : FieldInfoTestTargetBase
    {
#pragma warning disable 169
        public int Field1;
        private int Field2;
        public static int Field3;
        private static int Field4;
#pragma warning restore 169
    }

    public class MethodInfoTestTargetBase
    {
        public void BaseFunc1() { }
        public static void BaseFunc2() { }
    }
    public class MethodInfoTestTarget : MethodInfoTestTargetBase
    {
        public void Func1() { }
        private void Func2() { }
        public static void Func3() { }
        private static void Func4() { }
    }

}
